Package org.opencv.objdetect

## Class GraphicalCodeDetector

- java.lang.Object
- - org.opencv.objdetect.GraphicalCodeDetector

- Direct Known Subclasses:
    `BarcodeDetector`, `QRCodeDetector`, `QRCodeDetectorAruco`

      public class GraphicalCodeDetector
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected long` | `nativeObj` |

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `GraphicalCodeDetector​(long addr)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static GraphicalCodeDetector` | `__fromPtr__​(long addr)` |
    `java.lang.String` | `decode​(Mat img, Mat points)` | Decodes graphical code in image once it's found by the detect() method.
    `java.lang.String` | `decode​(Mat img, Mat points, Mat straight_code)` | Decodes graphical code in image once it's found by the detect() method.
    `boolean` | `decodeMulti​(Mat img, Mat points, java.util.List<java.lang.String> decoded_info)` | Decodes graphical codes in image once it's found by the detect() method.
    `boolean` | `decodeMulti​(Mat img, Mat points, java.util.List<java.lang.String> decoded_info, java.util.List<Mat> straight_code)` | Decodes graphical codes in image once it's found by the detect() method.
    `boolean` | `detect​(Mat img, Mat points)` | Detects graphical code in image and returns the quadrangle containing the code.
    `java.lang.String` | `detectAndDecode​(Mat img)` | Both detects and decodes graphical code
    `java.lang.String` | `detectAndDecode​(Mat img, Mat points)` | Both detects and decodes graphical code
    `java.lang.String` | `detectAndDecode​(Mat img, Mat points, Mat straight_code)` | Both detects and decodes graphical code
    `boolean` | `detectAndDecodeMulti​(Mat img, java.util.List<java.lang.String> decoded_info)` | Both detects and decodes graphical codes
    `boolean` | `detectAndDecodeMulti​(Mat img, java.util.List<java.lang.String> decoded_info, Mat points)` | Both detects and decodes graphical codes
    `boolean` | `detectAndDecodeMulti​(Mat img, java.util.List<java.lang.String> decoded_info, Mat points, java.util.List<Mat> straight_code)` | Both detects and decodes graphical codes
    `boolean` | `detectMulti​(Mat img, Mat points)` | Detects graphical codes in image and returns the vector of the quadrangles containing the codes.
    `protected void` | `finalize()` |
    `long` | `getNativeObjAddr()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### nativeObj

          protected final long nativeObj

  - ### Constructor Detail

    - #### GraphicalCodeDetector

          protected GraphicalCodeDetector​(long addr)

  - ### Method Detail

    - #### getNativeObjAddr

          public long getNativeObjAddr()

    - #### __fromPtr__

          public static GraphicalCodeDetector __fromPtr__​(long addr)

    - #### detect

          public boolean detect​(Mat img,
                                Mat points)

      Detects graphical code in image and returns the quadrangle containing the code.
      Parameters:
        `img` - grayscale or color (BGR) image containing (or not) graphical code.
        `points` - Output vector of vertices of the minimum-area quadrangle containing the code.
      Returns:
        automatically generated

    - #### decode

          public java.lang.String decode​(Mat img,
                                         Mat points,
                                         Mat straight_code)

      Decodes graphical code in image once it's found by the detect() method. Returns UTF8-encoded output string or empty string if the code cannot be decoded.
      Parameters:
        `img` - grayscale or color (BGR) image containing graphical code.
        `points` - Quadrangle vertices found by detect() method (or some other algorithm).
        `straight_code` - The optional output image containing binarized code, will be empty if not found.
      Returns:
        automatically generated

    - #### decode

          public java.lang.String decode​(Mat img,
                                         Mat points)

      Decodes graphical code in image once it's found by the detect() method. Returns UTF8-encoded output string or empty string if the code cannot be decoded.
      Parameters:
        `img` - grayscale or color (BGR) image containing graphical code.
        `points` - Quadrangle vertices found by detect() method (or some other algorithm).
      Returns:
        automatically generated

    - #### detectAndDecode

          public java.lang.String detectAndDecode​(Mat img,
                                                  Mat points,
                                                  Mat straight_code)

      Both detects and decodes graphical code
      Parameters:
        `img` - grayscale or color (BGR) image containing graphical code.
        `points` - optional output array of vertices of the found graphical code quadrangle, will be empty if not found.
        `straight_code` - The optional output image containing binarized code
      Returns:
        automatically generated

    - #### detectAndDecode

          public java.lang.String detectAndDecode​(Mat img,
                                                  Mat points)

      Both detects and decodes graphical code
      Parameters:
        `img` - grayscale or color (BGR) image containing graphical code.
        `points` - optional output array of vertices of the found graphical code quadrangle, will be empty if not found.
      Returns:
        automatically generated

    - #### detectAndDecode

          public java.lang.String detectAndDecode​(Mat img)

      Both detects and decodes graphical code
      Parameters:
        `img` - grayscale or color (BGR) image containing graphical code.
      Returns:
        automatically generated

    - #### detectMulti

          public boolean detectMulti​(Mat img,
                                     Mat points)

      Detects graphical codes in image and returns the vector of the quadrangles containing the codes.
      Parameters:
        `img` - grayscale or color (BGR) image containing (or not) graphical codes.
        `points` - Output vector of vector of vertices of the minimum-area quadrangle containing the codes.
      Returns:
        automatically generated

    - #### decodeMulti

          public boolean decodeMulti​(Mat img,
                                     Mat points,
                                     java.util.List<java.lang.String> decoded_info,
                                     java.util.List<Mat> straight_code)

      Decodes graphical codes in image once it's found by the detect() method.
      Parameters:
        `img` - grayscale or color (BGR) image containing graphical codes.
        `decoded_info` - UTF8-encoded output vector of string or empty vector of string if the codes cannot be decoded.
        `points` - vector of Quadrangle vertices found by detect() method (or some other algorithm).
        `straight_code` - The optional output vector of images containing binarized codes
      Returns:
        automatically generated

    - #### decodeMulti

          public boolean decodeMulti​(Mat img,
                                     Mat points,
                                     java.util.List<java.lang.String> decoded_info)

      Decodes graphical codes in image once it's found by the detect() method.
      Parameters:
        `img` - grayscale or color (BGR) image containing graphical codes.
        `decoded_info` - UTF8-encoded output vector of string or empty vector of string if the codes cannot be decoded.
        `points` - vector of Quadrangle vertices found by detect() method (or some other algorithm).
      Returns:
        automatically generated

    - #### detectAndDecodeMulti

          public boolean detectAndDecodeMulti​(Mat img,
                                              java.util.List<java.lang.String> decoded_info,
                                              Mat points,
                                              java.util.List<Mat> straight_code)

      Both detects and decodes graphical codes
      Parameters:
        `img` - grayscale or color (BGR) image containing graphical codes.
        `decoded_info` - UTF8-encoded output vector of string or empty vector of string if the codes cannot be decoded.
        `points` - optional output vector of vertices of the found graphical code quadrangles. Will be empty if not found.
        `straight_code` - The optional vector of images containing binarized codes
        - If there are QR codes encoded with a Structured Append mode on the image and all of them detected and decoded correctly, method writes a full message to position corresponds to 0-th code in a sequence. The rest of QR codes from the same sequence have empty string.
      Returns:
        automatically generated

    - #### detectAndDecodeMulti

          public boolean detectAndDecodeMulti​(Mat img,
                                              java.util.List<java.lang.String> decoded_info,
                                              Mat points)

      Both detects and decodes graphical codes
      Parameters:
        `img` - grayscale or color (BGR) image containing graphical codes.
        `decoded_info` - UTF8-encoded output vector of string or empty vector of string if the codes cannot be decoded.
        `points` - optional output vector of vertices of the found graphical code quadrangles. Will be empty if not found.
        - If there are QR codes encoded with a Structured Append mode on the image and all of them detected and decoded correctly, method writes a full message to position corresponds to 0-th code in a sequence. The rest of QR codes from the same sequence have empty string.
      Returns:
        automatically generated

    - #### detectAndDecodeMulti

          public boolean detectAndDecodeMulti​(Mat img,
                                              java.util.List<java.lang.String> decoded_info)

      Both detects and decodes graphical codes
      Parameters:
        `img` - grayscale or color (BGR) image containing graphical codes.
        `decoded_info` - UTF8-encoded output vector of string or empty vector of string if the codes cannot be decoded.
        - If there are QR codes encoded with a Structured Append mode on the image and all of them detected and decoded correctly, method writes a full message to position corresponds to 0-th code in a sequence. The rest of QR codes from the same sequence have empty string.
      Returns:
        automatically generated

    - #### finalize

          protected void finalize()
                           throws java.lang.Throwable

      Overrides:
        `finalize` in class `java.lang.Object`
      Throws:
        `java.lang.Throwable`